<?php include "../global/header.html"; ?>
    
<!-- Summary begins here -->

<table bgcolor="#FFFFFF" width="80%" align="center" cellpadding="20">
    <tr>
        <td>
            <H3>Title:  CD-ROM Tutorial</H3>
            <p>Author: Scott L. Patterson (patterson at accesstoledo.com)<br>
            Submission date: May 18, 2001</p>
	  
            <p>Description: A short tutorial demonstrating most of the CD functionality.</p>

            <p>Download: <a href="tut_cd.tar.gz">tut_cd.tar.gz</a></p>	  

            <p>pygame version required: Any<br>
            SDL version required: Any<br>
            Python version required: Any</p>

            <p>Comments: Here's a submission that runs through most of the commands that you'll need to use if you want to play cd music using pygame. Mr. Patterson's script provides some information about one of the present cdrom drives, gives us a track listing, then plays, pauses and resumes a music track. Finally, it attempts to eject the cd.</p>

	  <p>The code is pretty straightforward; I only found a couple of things confusing. First, the play/pause/resume loop is coded so that you expect it to play each track on the cd. However, it ejects the cd at the end of the loop, then breaks out of the for loop, meaning that only the first song is played. It's unclear from the code whether or not this was the intent. Second, I was unable to get the code to run without a pygame.error until I changed line 13 to read: cd_object = pygame.cdrom.CD(0). I believe this was because I have two cd-rom drives in my machine; I'm not sure exactly why this didn't work. Perhaps it was an error on my part.</p>
            
            <?php   $messages = explode("\n", `ls *.msg`);
                    array_pop($messages); ?>
                    
            <p><a href="#MESSAGES">Messages:</a> <?php echo count($messages); ?></p>
        </td>
    </tr>
</table>

<!-- Summary ends here -->

<!-- Code begins here -->

<pre>

import pygame

<span class="pydef">def main():</span>
    <span class="pycomment">"Demo the CD functionality"</span>

    <span class="pycomment"># Initialize the CDROM device</span>
    pygame.cdrom.init()
    print "<span class="pystring">CDROM initialized: </span>", pygame.cdrom.get_init()
    print "<span class="pystring">Number of CDROMs:  </span>", pygame.cdrom.get_count()

    <span class="pycomment"># Create a CDROM object if possible</span>
    if pygame.cdrom.get_count() > 0:
        cd_object = pygame.cdrom.CD(pygame.cdrom.get_count()-1)
        print "<span class="pystring">CDROM address:     </span>", cd_object

        <span class="pycomment"># These two functions do NOT require the CD to be initialzed</span>
        print "<span class="pystring">CDROM name:        </span>", cd_object.get_name()
        print "<span class="pystring">CDROM id:          </span>", cd_object.get_id()

        <span class="pycomment"># the following functions require that the CD is initialized</span>
        cd_object.init()

        <span class="pycomment"># Print information about each track nicely formatted</span>
        print
        print "<span class="pystring">Track  Audio  Start  Length</span>"
        print "<span class="pystring">-----  -----  -----  ------</span>"
        for i in range(cd_object.get_numtracks()):
            print "<span class="pystring">%5d  %5d  %5d  %6d</span>" % (i, 
                  cd_object.get_track_audio(i),
                  cd_object.get_track_start(i),
                  cd_object.get_track_length(i))
        print

        <span class="pycomment"># Let's play an audio track (hopefully)</span>
        audio_track_found = 0
        for i in range(cd_object.get_numtracks()):
            if cd_object.get_track_audio(i):
                audio_track_found = 1
                print "<span class="pystring">Playing Track </span>", i, "<span class="pystring"> for five seconds...</span>"
                cd_object.play(i)
                pygame.time.delay(5000)
                print "<span class="pystring">Pausing Track </span>", i, "<span class="pystring"> for five seconds...</span>"
                cd_object.pause()
                pygame.time.delay(5000)
                print "<span class="pystring">Resuming Track </span>", i, "<span class="pystring"> for five seconds...</span>"
                cd_object.resume()
                pygame.time.delay(5000)
                print "<span class="pystring">Stopping Track </span>", i, "<span class="pystring"> for five seconds...</span>"
                cd_object.stop()
                print "<span class="pystring">Ejecting CD...</span>"
                cd_object.eject()
                cd_object.quit()
                break

        if audio_track_found == 0:
            print "<span class="pystring">No audio tracks found.</span>"

    else:
        print "<span class="pystring">Please insert a CD into the CDROM and try again.</span>"

    <span class="pycomment"># Clean up</span>
    pygame.cdrom.quit()

if __name__ == '<span class="pystring">__main__</span>': main()

</pre>

<!-- Code ends here -->

<!-- Messages begin here -->

<?php include "../global/messages.php"; ?>

<?php include "../global/footer.html"; ?>

