<?php include "../global/header.html"; ?>
    
<!-- Summary begins here -->

<table bgcolor="#FFFFFF" width="80%" align="center" cellpadding="20">
    <tr>
        <td>
            <H3>Title:  Skyscraper</H3>
            <p>Author: Richard Jones (richardjones at optushome.com.au)<br>
            Submission date: December 09, 2001</p>
	  
            <p>Description: Displays words loaded from the supplied website, using a variety of typographic effects.</p>
            
            <p align="center"><img src="skyscraper_shot2.png" width="648" height="508"></p>

            <p>Download: <a href="skyscraper.tgz">skyscraper.tgz</a></p>	  

            <p>pygame version required: Any (Numeric Required)<br>
            SDL version required: Any<br>
            Python version required: Any</p>

            <p>Comments: I haven't read the book Mr. Jones refers to, although I've seen the Underworld album cover, and the effect looks right.  Invoke the program like this : <pre>python skyscraper.py url</pre>, where <i>url</i> is something like &quot;http://www.pygame.org&quot;.  The script is sensitive to the presence of fonts on your system - if you start getting errors, try putting a couple of fonts in the script's directory.</p>
            
            <?php   $messages = explode("\n", `ls *.msg`);
                    array_pop($messages); ?>
                    
            <p><a href="#MESSAGES">Messages:</a> <?php echo count($messages); ?></p>
        </td>
    </tr>
</table>

<!-- Summary ends here -->

<!-- Code begins here -->

<pre>

<span class="pycomment">#!/usr/bin/env python
'''mmm...
         skyscraper       i love you

   this program is inspired by the book "mmm... skyscraper i love you" by
   Tomato / Underworld
   
   i would like to try to set it to music some day

   it would also be nice to have some more structure to the chaos... do some
   low-frequency stuff first and then a couple of high-frequency bits...



      richardjones@optushome.com.au

   thanks to pete shinners for pygame and the original font demo
             graham for the fonts... http://grudnuk.com/fonts/

   this code is placed in the public domain
'''</span>

<span class="pycomment"># import every damn thing we can find...</span>
import os, sys, math, random, time
import urllib, htmllib, formatter, string, re
try:
    import pygame
except ImportError, message:
    print "<span class="pystring">You need pygame to run this script! (%s)</span>"%message
    sys.exit(0)
import pygame.font
import pygame.image
import pygame.transform
import pygame.surfarray
from pygame.locals import *
try:
    from Numeric import array
except ImportError, message:
    print "<span class="pystring">You need Numeric to run this script! (%s)</span>"%message
    sys.exit(0)

<span class="pydef">class Skyscraper:</span>
    <span class="pycomment"># initialise the fonts array</span>
    data = '<span class="pystring">data</span>'
    fonts = []
    for entry in os.listdir(data):
        fonts.append(os.path.join(data, entry))

    <span class="pydef">def __init__(self, text, screensize):</span>
        <span class="pycomment">'''Generate an image using the text (a single word) using a random
        font, size and intensity. Then manipulate it randomly using any of
        the do_foo methods.
        '''</span>
        self.screensize = screensize
        size = random.randint(1, 200)
        face = random.choice(self.fonts)
        font = pygame.font.Font(face, size)
        level = random.randint(0, 255)
        surf = font.render(text, 2, (level, level, level))
        self.surface = surf
        for i in range(random.randint(1, 2)):
            method = random.choice(self.methods)
            meth = getattr(self, method)()

    <span class="pydef">def do_subtract(self):</span>
        <span class="pycomment">'''Invert the image so it'll subtract from the destination.
           This is achieved by just setting the colour to black and leaving
           the alpha channel alone.
        '''</span>
        s = pygame.surfarray.pixels3d(self.surface)
        s[:,:,:] = 0

    <span class="pydef">def do_nothing(self):</span>
        <span class="pycomment">'''Leave the text alone, just like it was when the stork dropped it
        off.
        '''</span>
        pass

    <span class="pydef">def do_smudge(self):</span>
        <span class="pycomment">'''Jiggle the text around a bit.
           We fiddle the image's alpha channel and then repeatedly draw it
           onto another surface at different positions.
        '''</span>
        src = self.surface
        w, h = src.get_size()
        <span class="pycomment"># make the width a little saner so we don't do unnecessary</span>
        <span class="pycomment"># processing</span>
        if w > self.screensize[0]:
            w = self.screensize[0]

        <span class="pycomment"># halve the alpha channel</span>
        a = pygame.surfarray.pixels_alpha(src)
        a /= array(random.randint(1, 8)).astype('<span class="pystring">b</span>')
        newsize = w+20, h+20
        temp = pygame.Surface(newsize, 0, 24)
        for i in range(random.randint(5, 10)):
            temp.blit(src, (random.randint(0, 20), random.randint(0, 20)))

        <span class="pycomment"># make a new surface with alhpa and copy in the red channel from</span>
        <span class="pycomment"># the greyscale temp surface as the alpha channel.</span>
        self.surface = pygame.Surface(newsize, 0, src)
        self.surface.fill((255,255,255,255))
        newalpha = pygame.surfarray.pixels_alpha(self.surface)
        srcalpha = pygame.surfarray.pixels3d(temp)
        newalpha[:,:] = srcalpha[:,:,0]


    <span class="pydef">def do_repeat(self):</span>
        <span class="pycomment">'''Repeat the text on 2 <= n < =20 lines.
        '''</span>
        src = self.surface
        w, h = src.get_size()
        if w > self.screensize[0]:
            w = self.screensize[0]

        <span class="pycomment"># same as smudge, but we halve the alpha channel</span>
        n = random.randint(2, 20)
        max_n = self.screensize[1]/h
        if n > max_n: n = max_n
        newsize = w, h * n
        temp = pygame.Surface(newsize, 0, 24)
        for i in range(n):
            temp.blit(src, (0, h*i))

        <span class="pycomment"># make a new surface with alhpa and copy in the red channel from</span>
        <span class="pycomment"># the greyscale temp surface as the alpha channel.</span>
        self.surface = pygame.Surface(newsize, 0, src)
        self.surface.fill((255,255,255,255))
        newalpha = pygame.surfarray.pixels_alpha(self.surface)
        srcalpha = pygame.surfarray.pixels3d(temp)
        newalpha[:,:] = srcalpha[:,:,0]


    <span class="pydef">def do_mag(self):</span>
        <span class="pycomment">'''Do a simple magnification of the text.
        '''</span>
        src = self.surface
        w, h = src.get_size()
        <span class="pycomment"># figure the size of subsection of the surface</span>
        sw, sh = w/2, h/2
        x, y = random.randint(0, w-sw), random.randint(0, h-sh)
        dst = src.subsurface((x, y, sw, sh))
        self.surface = pygame.transform.scale(dst, (w*2, h*2))


    <span class="pydef">def do_flip(self):</span>
        <span class="pycomment">'''Flip the text in one or more axes.
        '''</span>
        a = pygame.surfarray.pixels_alpha(self.surface)
        a /= array(2).astype('<span class="pystring">b</span>')
        self.surface = pygame.transform.flip(self.surface,
            random.randint(0,1), random.randint(0,1))


<span class="pydef">class WordSucker(formatter.NullWriter):</span>
    <span class="pycomment">'''This is a writer for the parser/formatter/writer trio that does
       HTMLParsing in python. All I do here is accept the data (which will
       be the stuff between HTML tags) and accept all the words - which I
       define as only having letters in them - no numbers, no digits, ...
    '''</span>
    <span class="pydef">def __init__(self):</span>
        formatter.NullWriter.__init__(self)
        self.words = []

    <span class="pydef">def send_flowing_data(self, data):</span>
        for word in data.split():
            if re.search(r'<span class="pystring">[\W\d_]</span>', word): continue
            self.words.append(word)

<span class="pydef">def main():</span>
    <span class="pycomment"># figure all the fun methods</span>
    Skyscraper.methods = []
    for method in Skyscraper.__dict__.keys():
        if method.startswith('<span class="pystring">do_</span>'):
            Skyscraper.methods.append(method)

    pygame.init()

    <span class="pycomment"># create a window the correct size</span>
    width, height = 640, 480
    win = pygame.display.set_mode((width, height)) #, FULLSCREEN)

    <span class="pycomment">#wait for the finish</span>
    finished = 0

    <span class="pycomment"># get the words!</span>
    if len(sys.argv) > 1:
        f = urllib.urlopen(sys.argv[1])
    else:
        f = sys.stdin
    data = f.read()
    if f is not sys.stdin:
        f.close()
    wordsucker = WordSucker()
    parser = htmllib.HTMLParser(formatter.AbstractFormatter(wordsucker))
    parser.feed(data)
    parser.close()

    <span class="pycomment"># loop indefinitely, displaying all the words we got from the source.</span>
    <span class="pycomment"># Clear the display once in a while</span>
    i = 0
    target = random.randint(10,20)
    while 1:
        for entry in wordsucker.words:
            for event in pygame.event.get():
                if event.type is KEYDOWN and event.key == K_s: #save it
                    name = os.path.splitext(sys.argv[0])[0] + '<span class="pystring">.bmp</span>'
                    print '<span class="pystring">Saving image to:</span>', name
                    pygame.image.save(win, name)
                elif event.type in (QUIT, KEYDOWN, MOUSEBUTTONDOWN):
                    sys.exit(0)

            <span class="pycomment"># delay and possibly clear</span>
            if i > target:
                time.sleep(5)
                win.fill((0,0,0))
                i = 0
                target = random.randint(10,20)
            i = i + 1

            <span class="pycomment"># create one of our random images</span>
            im = Skyscraper(entry, (width, height))
            w, h = im.surface.get_size()
            x, y = random.randint(-w, width), random.randint(-h, height)
            win.blit(im.surface, (x, y))
            pygame.display.flip()

if __name__ == '<span class="pystring">__main__</span>':
    if sys.argv[1] == '<span class="pystring">-h</span>':
        print "<span class="pystring">Usage: %s &lt;url to load text from&gt;</span>"
    else:
        main()


</pre>

<!-- Code ends here -->

<!-- Messages begin here -->

<?php include "../global/messages.php"; ?>

<?php include "../global/footer.html"; ?>

