<?php include "../global/header.html"; ?>
    
<!-- Summary begins here -->

<table bgcolor="#FFFFFF" width="80%" align="center" cellpadding="20">
    <tr>
        <td>
            <H3>Title:  UserRect Class</H3>
            <p>Author: Pete Shinners (pete at shinners.org)<br>
            Submission date: January 04, 2002</p>
	  
            <p>Description: A subclassable wrapper around the Rect class for Python 2.1 and older.</p>

            <p>Download: <a href="UserRect.py">UserRect.py</a></p>	  

            <p>pygame version required: Any<br>
            SDL version required: Any<br>
            Python version required: Any (not needed with 2.0)</p>

            <p>Comments: Before the class/type unification that was included in Python 2.2, data types implemented in C (such as pygame's Rect class) weren't considered true classes - they couldn't be subclassed.  Pete included the UserRect module in the pygame distribution to get around that - it's just the thinnest possible python wrapper around Rect.  I dont think anyone ever used it for anything, but in case someone misses it, here it is.  It might be handy for a game like Breakout, where everything is rectangular, and you could create a simple sprite class as &quot;class Sprite(UserRect):&quot;.  However, it would be cleaner and faster just to upgrade to python 2.2, and subclass the actual Rect class.</p>
            
            <?php   $messages = explode("\n", `ls *.msg`);
                    array_pop($messages); ?>
                    
            <p><a href="#MESSAGES">Messages:</a> <?php echo count($messages); ?></p>
        </td>
    </tr>
</table>

<!-- Summary ends here -->

<!-- Code begins here -->

<pre>

<span class="pycomment">"""UserRect, python class wrapped around the pygame Rect type. This allows
you to do things like inherit the rectangle object into a sprite class. While
this makes for some neat features, current testing has shown there is a bit of
a peformance penalty. (as opposed to just keeping a Rect value inside the class)

Note, this might be worthless now, as python-2.2 allows you to subclass real
python types, no need for this placeholder. Still, it may provide some assistance
to somebody out there.
"""</span>

from pygame.rect import Rect


<span class="pydef">class UserRect:</span>
    <span class="pycomment">"""UserRect() -> class instance
Python class for the pygame Rect type

This python class can be treated exactly like a normal Rect
object. The only difference is it is a real python class
object, not a C extension type.
"""</span>
    <span class="pydef">def __init__(self, *args):</span>
        try: self.__dict__['<span class="pystring">rect</span>'] = apply(Rect, args)
        except TypeError:
            raise TypeError, '<span class="pystring">Argument must be rectstyle object</span>'
        for a in dir(self.rect):
            self.__dict__[a] = getattr(self.rect, a)

    <span class="pydef">def __getattr__(self, name):</span>
        return getattr(self.rect, name)
    <span class="pydef">def __setattr__(self, name, val):</span>
        if name is '<span class="pystring">rect</span>':
            self.__dict__['<span class="pystring">rect</span>'][:] = val
        else:
            try: setattr(self.__dict__['<span class="pystring">rect</span>'], name, val)
            except (AttributeError, KeyError): self.__dict__[name] = val
    <span class="pydef">def __len__(self):</span> return 4
    <span class="pydef">def __getitem__(self, i):</span> return self.rect[i]
    <span class="pydef">def __setitem__(self, i, val):</span> self.rect[i] = val
    <span class="pydef">def __getslice__(self, i, j):</span> return self.rect[i:j]
    <span class="pydef">def __setslice__(self, i, j, val):</span> self.rect[i:j] = val
    <span class="pydef">def __nonzero__(self):</span> return nonzero(self.rect)
    <span class="pydef">def __cmp__(self, o):</span> return cmp(self.rect, o)
    <span class="pydef">def __repr__(self):</span>
        return '<span class="pystring">&lt;UserRect(%d, %d, %d, %d)&gt;</span>' % tuple(self.rect)
    <span class="pydef">def __str__(self):</span>
        return '<span class="pystring">&lt;UserRect(%d, %d, %d, %d)&gt;</span>' % tuple(self.rect)

</pre>

<!-- Code ends here -->

<!-- Messages begin here -->

<?php include "../global/messages.php"; ?>

<?php include "../global/footer.html"; ?>

